local Tinkr, Bastion = ...

Tinkr:require('scripts.bastion.libs.LibStub.LibStub', Bastion)
Tinkr:require("scripts.bastion.libs.StdUi.StdUi", Bastion)
Tinkr:require("scripts.bastion.libs.StdUi.StdUiConfig", Bastion)
Tinkr:require("scripts.bastion.libs.StdUi.StdUiPosition", Bastion)
Tinkr:require("scripts.bastion.libs.StdUi.StdUiUtil", Bastion)
Tinkr:require("scripts.bastion.libs.StdUi.StdUiLayout", Bastion)
Tinkr:require("scripts.bastion.libs.StdUi.StdUiGrid", Bastion)
Tinkr:require("scripts.bastion.libs.StdUi.StdUiBuilder", Bastion)
Tinkr:require("scripts.bastion.libs.StdUi.StdUiBuilder", Bastion)
Tinkr:require("scripts.bastion.libs.StdUi.widgets.Basic", Bastion)
Tinkr:require("scripts.bastion.libs.StdUi.widgets.Window", Bastion)
Tinkr:require("scripts.bastion.libs.StdUi.widgets.Button", Bastion)
Tinkr:require("scripts.bastion.libs.StdUi.widgets.EditBox", Bastion)
Tinkr:require("scripts.bastion.libs.StdUi.widgets.CheckBox", Bastion)
Tinkr:require("scripts.bastion.libs.StdUi.widgets.Dropdown", Bastion)
Tinkr:require("scripts.bastion.libs.StdUi.widgets.Autocomplete", Bastion)
Tinkr:require("scripts.bastion.libs.StdUi.widgets.Label", Bastion)
Tinkr:require("scripts.bastion.libs.StdUi.widgets.Scroll", Bastion)
Tinkr:require("scripts.bastion.libs.StdUi.widgets.ScrollTable", Bastion)
Tinkr:require("scripts.bastion.libs.StdUi.widgets.Slider", Bastion)
Tinkr:require("scripts.bastion.libs.StdUi.widgets.Tooltip", Bastion)
Tinkr:require("scripts.bastion.libs.StdUi.widgets.Table", Bastion)
Tinkr:require("scripts.bastion.libs.StdUi.widgets.ProgressBar", Bastion)
Tinkr:require("scripts.bastion.libs.StdUi.widgets.ColorPicker", Bastion)
Tinkr:require("scripts.bastion.libs.StdUi.widgets.Tab", Bastion)
Tinkr:require("scripts.bastion.libs.StdUi.widgets.Spell", Bastion)
Tinkr:require("scripts.bastion.libs.StdUi.widgets.ContextMenu", Bastion)

local class = UnitClass('player')
local spec = GetSpecialization()
local guiconf = Tinkr.Util.Config:New(class .. spec)
local mainmenufirstloadcheck = guiconf:Read("mainmenue")
if not mainmenufirstloadcheck then
  guiconf:Write("mainmenua", 'CENTER')
end
local settingsmenufirstloadcheck = guiconf:Read("settingsmenue")
if not settingsmenufirstloadcheck then
  guiconf:Write("settingsmenua", 'CENTER')
end
--Initial Frame Setup
function Bastion.settingstemplate(config, title, width, height, newr, newg, newb)
  --UI Co-ordinates
    local StdUi = LibStub('StdUi'):NewInstance()
    StdUi.config = {
      font        = {
        family    = 'GameFontNormal',
        size      = 10,
        titleSize = 10,
        effect    = 'NONE',
        strata    = 'OVERLAY',
        color     = {
          normal   = { r = 1, g = 1, b = 1, a = 1 },
          disabled = { r = 0.55, g = 0.55, b = 0.55, a = 1 },
          header   = { r = newr, g = newg, b = newb, a = 1 },
        }
      },
      backdrop    = {
        texture        = [[Interface\Buttons\WHITE8X8]],
        panel          = { r = 0.0588, g = 0.0588, b = 0, a = 0.8 },
        slider         = { r = newr, g = newg, b = newb, a = 1 },

        highlight      = { r = 0.40, g = 0.40, b = 0.40, a = 0.5 },
        button         = { r = 0.20, g = 0.20, b = 0.20, a = 1 },
        buttonDisabled = { r = 0.15, g = 0.15, b = 0.15, a = 1 },

        border         = { r = 0.00, g = 0.00, b = 0.00, a = 1 },
        borderDisabled = { r = 0.40, g = 0.40, b = 0.40, a = 1 }
      },
      progressBar = { color = { r = newr, g = newg, b = newb, a = 0.5 }, },
      highlight   = {
        color = { r = newr, g = newg, b = newb, a = 0.4 },
        blank = { r = 0, g = 0, b = 0, a = 0 }
      },
      dialog      = {
        width  = 400,
        height = 100,
        button = {
          width  = 100,
          height = 20,
          margin = 5
        }
      },
      tooltip     = { padding = 10 }
    }

    local settingsframe = StdUi:Window(UIParent, width, height, title)
    local settingsmenua = guiconf:Read("settingsmenua")
    local settingsmenuc = guiconf:Read("settingsmenuc")
    local settingsmenud = guiconf:Read("settingsmenud")
    local settingsmenue = guiconf:Read("settingsmenue")
    settingsframe:Hide()
    settingsframe:SetPoint(settingsmenua, nil, settingsmenuc, settingsmenud, settingsmenue)
    StdUi:BuildWindow(settingsframe, config)
    StdUi:EasyLayout(settingsframe, { padding = { top = 40 } })
    settingsframe:SetScript("OnDragStop", function(self)
      local a,b,c,d,e = self:GetPoint()
      --Bastion:Print(a,b,c,d,e)
      self:StopMovingOrSizing()
      guiconf:Write("settingsmenua", a)
      guiconf:Write("settingsmenuc", c)
      guiconf:Write("settingsmenud", d)
      guiconf:Write("settingsmenue", e)
    end)

    --Main Menu (Settings, Enable Rotation, etc)
    _G.buttons = {}
    buttons.aoeenabled = false
    buttons.buffsenabled = false
    buttons.cooldownsenabled = false
    buttons.dispelenabled = false
    buttons.dpsenabled = false
    buttons.healenabled = false
    buttons.rotationenabled = false
    local mainmenua = guiconf:Read("mainmenua")
    local mainmenuc = guiconf:Read("mainmenuc")
    local mainmenud = guiconf:Read("mainmenud")
    local mainmenue = guiconf:Read("mainmenue")
    _G.mainmenu = StdUi:Window(nil, 260, 110, title)
    mainmenu:Hide()
    mainmenu:SetPoint(mainmenua, nil, mainmenuc, mainmenud, mainmenue)
    local aoebutton = StdUi:HighlightButton(mainmenu, 80, 20, 'AOE')
    StdUi:GlueTop(aoebutton, mainmenu, 5, -35, 'LEFT')
    local buffsbutton = StdUi:HighlightButton(mainmenu, 80, 20, 'Buffs')
    StdUi:GlueRight(buffsbutton, aoebutton, 5, 0, nil)
    local cooldownsbutton = StdUi:HighlightButton(mainmenu, 80, 20, 'Cooldowns')
    StdUi:GlueRight(cooldownsbutton, buffsbutton, 5, 0, nil)
    local dispelbutton = StdUi:HighlightButton(mainmenu, 80, 20, 'Dispel')
    StdUi:GlueTop(dispelbutton, aoebutton, 0, -25, 'LEFT')
    local dpsbutton = StdUi:HighlightButton(mainmenu, 80, 20, 'DPS')
    StdUi:GlueRight(dpsbutton, dispelbutton, 5, 0, nil)
    local healbutton = StdUi:HighlightButton(mainmenu, 80, 20, 'Heal')
    StdUi:GlueRight(healbutton, dpsbutton, 5, 0, nil)
    local enablebutton = StdUi:HighlightButton(mainmenu, 80, 20, 'Rotation')
    StdUi:GlueTop(enablebutton, dispelbutton, 0, -25, 'LEFT')
    local settingsbutton = StdUi:Button(mainmenu, 80, 20, 'Settings')
    StdUi:GlueRight(settingsbutton, enablebutton, 5, 0, nil)
    mainmenu:SetScript("OnDragStop", function(self)
      local a,b,c,d,e = self:GetPoint()
      --Bastion:Print(a,b,c,d,e)
      self:StopMovingOrSizing()
      guiconf:Write("mainmenua", a)
      guiconf:Write("mainmenuc", c)
      guiconf:Write("mainmenud", d)
      guiconf:Write("mainmenue", e)
    end)

    --Open/Hide Settings Window OnClick
    settingsbutton:SetScript('OnClick', function ()
      if settingsframe:IsShown() then
        settingsframe:Hide()
      else
        settingsframe:Show()
      end
    end)
    --Enable/Disable AOE Button OnClick
    aoebutton:SetScript('OnClick', function()
      if buttons.aoeenabled == false then
        aoebutton:LockHighlight()
        buttons.aoeenabled = true
      elseif buttons.aoeenabled == true then
        aoebutton:UnlockHighlight()
        buttons.aoeenabled = false
      end
    end)
    --Enable/Disable Buffs Button OnClick
    buffsbutton:SetScript('OnClick', function()
      if buttons.buffsenabled == false then
        buffsbutton:LockHighlight()
        buttons.buffsenabled = true
      elseif buttons.buffsenabled == true then
        buffsbutton:UnlockHighlight()
        buttons.buffsenabled = false
      end
    end)
    --Enable/Disable Cooldown Button OnClick
    cooldownsbutton:SetScript('OnClick', function()
      if buttons.cooldownsenabled == false then
        cooldownsbutton:LockHighlight()
        buttons.cooldownsenabled = true
      elseif buttons.cooldownsenabled == true then
        cooldownsbutton:UnlockHighlight()
        buttons.cooldownsenabled = false
      end
    end)
    --Enable/Disable Dispel Button OnClick
    dispelbutton:SetScript('OnClick', function()
      if buttons.dispelenabled == false then
        dispelbutton:LockHighlight()
        buttons.dispelenabled = true
      elseif buttons.dispelenabled == true then
        dispelbutton:UnlockHighlight()
        buttons.dispelenabled = false
      end
    end)
    --Enable/Disable DPS Button OnClick
    dpsbutton:SetScript('OnClick', function()
      if buttons.dpsenabled == false then
        dpsbutton:LockHighlight()
        buttons.dpsenabled = true
      elseif buttons.dpsenabled == true then
        dpsbutton:UnlockHighlight()
        buttons.dpsenabled = false
      end
    end)
    --Enable/Disable Heal Button OnClick
    healbutton:SetScript('OnClick', function()
      if buttons.healenabled == false then
        healbutton:LockHighlight()
        buttons.healenabled = true
      elseif buttons.healenabled == true then
        healbutton:UnlockHighlight()
        buttons.healenabled = false
      end
    end)
    --Enable/Disable Rotation Button OnClick HIGHLIGHT ONLY
    enablebutton:SetScript('OnClick', function()
      if buttons.rotationenabled == false then
        enablebutton:LockHighlight()
        Eval('RunMacroText("/bastion toggle")', 'bastion')
        buttons.rotationenabled = true
      elseif buttons.rotationenabled == true then
        enablebutton:UnlockHighlight()
        Eval('RunMacroText("/bastion toggle")', 'bastion')
        buttons.rotationenabled = false
      end
    end)

end